C----------------------------------------------------------------------
        subroutine ftpclm(ounit,colnum,frow,felem,nelem,array,status)

C       write an array of double precision complex data values to the 
C       specified column of the table.  
C       The binary table column being written to must have datatype 'M'
C       and no datatype conversion will be perform if it is not.

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       felem   i  first element within the row to write
C       nelem   i  number of elements to write
C       array   dcmp  array of data values to be written 
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,colnum,frow,felem,nelem,status
C       array is really double precison complex
        double precision array(*)
        integer felemx, nelemx

C       simply multiply the number of elements by 2, and call ftpcld
C       Technically, this is not strictly correct because the data scaling
C       (with TSCALn and TZEROn) is applied differently to complex numbers.
C       In practice, complex number will probably never be scaled so
C       this complication will be ignored.

        felemx = (felem - 1) * 2 + 1
        nelemx  = nelem * 2
        call ftpcld(ounit,colnum,frow,felemx,nelemx,array,status)

        end
